"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var isWindows = /^win/i.test(process.platform);
/**
 * Sometimes, people want to look for local executable files
 * which are specified with either relative or absolute file path.
 * @private
 * @param cmd
 * @return {string} An absolute path of given command, or undefined.
 */
var isFilepath = function (cmd) {
    return cmd.includes(path.sep) ? path.resolve(cmd) : undefined;
};
/**
 * In Windows OS, there are aliases to executable files, like ".sh", ".bash" or ".py".
 * @private
 * @return {string[]}
 */
var getApplicableExtensions = function () {
    return (isWindows) ? (process.env.PATHEXT || '').split(path.delimiter) : [''];
};
/**
 * Just promisifies "fs.access"
 * @private
 * @param {string} absWithExt An absolute file path with an applicable extension appended.
 * @return {Promise<string>} Resolves absolute path or empty string.
 */
var access = function (absWithExt) {
    return new Promise(function (resolve) { return fs.access(absWithExt, fs.constants.X_OK, function (err) { return resolve(err ? '' : absWithExt); }); });
};
/**
 * Resolves if the given file is executable or not, regarding "PATHEXT" to be applied.
 * @private
 * @param {string} abspath A file path to be checked.
 * @return {Promise<string>} Resolves the absolute file path just checked, or undefined.
 */
var isExecutable = function (abspath) { return __awaiter(_this, void 0, void 0, function () {
    var checks, abspathes;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                checks = getApplicableExtensions().map(function (ext) { return access(abspath + ext); });
                return [4 /*yield*/, Promise.all(checks)];
            case 1:
                abspathes = _a.sent();
                return [2 /*return*/, Promise.resolve(abspathes.filter(function (abs) { return !!abs; })[0])];
        }
    });
}); };
/**
 * Just to list up all the files under the directory given.
 * @param {string} dir An absolute directory path to list the contents.
 * @return {Promise<string[]>} Resolves the list of contents of this directory.
 */
var ls = function (dir) {
    return new Promise(function (resolve) { return fs.readdir(dir, function (err, files) { return resolve(files || []); }); });
};
/**
 * Returns all executable files which have the same name with the target command.
 * @private
 * @param {string} cmd The target command we are looking for.
 * @param {string} dir The target directory in which the command would be looked for.
 */
var findExecutableUnderDir = function (cmd, dir) { return __awaiter(_this, void 0, void 0, function () {
    var files, matches;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, ls(dir)];
            case 1:
                files = _a.sent();
                matches = files.filter(function (f) { return path.basename(f).split('.')[0] === cmd; });
                return [2 /*return*/, Promise.all(matches.map(function (f) { return isExecutable(path.join(dir, f)); }))];
        }
    });
}); };
/**
 * Returns a list of directories on which the target command should be looked for.
 * @private
 * @param {string[]} additional Additional pathes to loook for, already splitted by OS-depending path delimiter.
 * @return {string[]} Directories to dig into.
 */
var getDirsToWalkThrough = function (additionalPaths) {
    if (additionalPaths === void 0) { additionalPaths = []; }
    var envname = isWindows ? 'Path' : 'PATH';
    return (process.env[envname] || '').split(path.delimiter).concat(additionalPaths);
};
/**
 * Just to flatten nested lists.
 * @private
 * @param {T[][]} arr
 * @return {T[]}
 */
var flatten = function (arr) {
    return arr.reduce(function (prev, curr) { return prev.concat(curr); }, []);
};
/**
 * Returns async promise with absolute file path of given command,
 * and resolves with undefined if the command not found.
 * @param {string} command Command name to look for.
 * @param {LookPathOption} opt Options for lookpath.
 * @return {Promise<string>} Resolves absolute file path, or undefined if not found.
 */
function lookpath(command, opt) {
    if (opt === void 0) { opt = { path: [] }; }
    return __awaiter(this, void 0, void 0, function () {
        var directpath, dirs, detections, matched;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    directpath = isFilepath(command);
                    if (directpath)
                        return [2 /*return*/, isExecutable(directpath)];
                    if (!opt.path)
                        opt.path = [];
                    dirs = getDirsToWalkThrough(opt.path);
                    detections = dirs.map(function (dir) { return findExecutableUnderDir(command, dir); });
                    return [4 /*yield*/, Promise.all(detections)];
                case 1:
                    matched = _a.sent();
                    return [2 /*return*/, flatten(matched).filter(function (abs) { return !!abs; })[0]];
            }
        });
    });
}
exports.lookpath = lookpath;
;
